(** Le code de la machine abstraite pour PCF *)

(** Les instructions comme dans le cours *)
type instruction =
 | Ldi of int
 | Push
 | IOp of Op.t
 | Extend
 | Search of int
 | Pushenv
 | Popenv
 | Mkclos of code    (* Fabriquer une fermeture ordinaire *)
 | Mkclosrec of code (* Fabriquer une fermeture recursive *)
 | Apply
 | Test of code * code

and code = instruction list

(** Divers  afficheurs *)

open Printf

let string_of_instr = function
  | Ldi i    -> sprintf "Ldi %i" i
  | Push     -> "Push"
  | IOp op   -> sprintf "IOp(%c)" (Op.to_char op)
  | Extend   -> "Extend"
  | Search k -> sprintf "Search %i" k
  | Pushenv  -> "Pushenv"
  | Popenv   -> "Popenv"
  | Mkclos _ -> "Mkclos"
  | Mkclosrec _ -> "Mkclosrec"
  | Apply    -> "Apply"
  | Test _   -> "Test"

open Printf

let print_instruction chan i = fprintf chan "%s" (string_of_instr i)

let print_code chan c =
  List.iter
    (fun i -> fprintf chan "%a\n" print_instruction i)
    c

