(** Abres de syntaxe abstraite pour iPCF *)

(** Les quatre oprations, premier argument du
    constructeur [Op] ci-dessous. *)
type op = Add | Sub | Mul | Div

(** Type de la syntaxe abstraite des termes de iPCF. *)
type t =
  | Unit                        (** L'unit, i.e. ne rien faire *)
  | Num of int                  (** Constante entire *)
  | Ref of t                 (** Nouvelle rfrence avec valeur initiale. *)
  | Var of string               (** Accs  une variable *)
  | Set of t * t          (** Assignation [t1:=t2] *)
  | Get of t                 (** Drfrencement [!t] *)
  | Op  of op * t * t     (** Application d'un oprateur [t1 op t2] *)
  | Ifz of t * t * t   (** Conditionnelle [Ifz t1 Then t2 Else t3] *)
  | Let of string * t * t (** Liaison locale [Let x = t1 In t2] *) 
  | App of t * t          (** Application de fonction [t1 t2]*)
  | Fun of string * t        (** Dfinition de fonction [Fun x -> t] *)
  | Fix of string * t        (** Point fixe [Fix x -> t] *)
  | Seq of t * t          (** Composition squentielle [t1;t2] *)

type 'a env = (string * 'a) list
