open Pcf

let print chan (s,v) =
  Machine.print_value chan v ;
  output_string chan " : " ;
  Eq.print_scheme chan s

let rec split_env env = match env with
| [] -> [],[]
| (x,(s,v))::env ->
    let env_t, env_v = split_env env in
    (x,s)::env_t, (x,v)::env_v

let eval env t =
  let comp_env,exec_env = List.split env in
  let c = Compiler.compile comp_env t in
  Machine.exec exec_env c

let infer_eval env t =
  let env_t,env_v = split_env env in
  let s = Poly.infer_scheme env_t t in
  let v = eval env_v t in
  (s,v)

  
let () = S.Top.loop print infer_eval

