%{
open Op
open Type
open Ast

let mk_fix (x,t) e = Fix (x,t,e)
and mk_fun  (x,t) e = Fun (x,t,e)

%}

%token <int> INT
%token <string> IDENT
%token ADD SUB MUL DIV
%token EQUAL ARROW
%token OPAR CPAR
%token FUN FIX
%token LET IN REC
%token IFZ THEN ELSE
%token EOF SEMISEMI
%token COLON NAT

/* lowest precedence */
%left  ADD SUB
%left  MUL DIV

/* Simply typed PCF */
%start main             
%type <Ast.t> main
%start top
%type <string option * Ast.t> top
%%

/* Horrible, il fait presque tout refaire */

main:
| t3 EOF { $1 }
| t3 SEMISEMI EOF { $1 }

top:
| t3 SEMISEMI { (None,$1) }
| LET IDENT EQUAL t3 SEMISEMI { (Some $2,$4) }
| LET REC ptidentopt EQUAL t3 SEMISEMI { (Some (fst $3),mk_fix $3 $5) }
| EOF { raise Exit }

t3:
| t2   { $1 }
| FUN ptident ARROW t3 { mk_fun $2 $4 }
| FIX ptident ARROW t3 { mk_fix $2 $4 }
| LET IDENT EQUAL t3 IN t3 { Let ($2,$4,$6) }
| LET REC ptidentopt EQUAL t3 IN t3 { Let (fst $3,mk_fix $3 $5,$7) }
| IFZ t3 THEN t3 ELSE t3 { Ifz ($2, $4,$6) }

t2:
| t1 { $1 }
| t2 ADD t2 { Op (Op.Add,$1,$3) }
| t2 SUB t2 { Op (Op.Sub,$1,$3) }
| t2 MUL t2 { Op (Op.Mul,$1,$3) }
| t2 DIV t2 { Op (Op.Div,$1,$3) } 
 
t1:
| t0 { $1 }
| t1 t0 { App($1, $2) }


t0:
| INT { Num $1 }
| IDENT { Var $1 }
| OPAR t3 CPAR { $2 }

ptident:
| OPAR tident CPAR { $2 }

tident:
| IDENT COLON ty { ($1,$3) }

ptidentopt:
| ptident { $1 }
| tident  { $1 }

ty:
| ty0 { $1 }
| ty0 ARROW ty { Arrow ($1, $3) }

ty0:
| NAT { Nat }
| OPAR ty CPAR { $2 }
